# Copyright (c) 2000-2005, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define gcj_support %{?_with_gcj_support:1}%{!?_with_gcj_support:%{?_without_gcj_support:0}%{!?_without_gcj_support:%{?_gcj_support:%{_gcj_support}}%{!?_gcj_support:0}}}

%define	section		free
%define	bname		openejb

Name:		openejb2
Summary:	EJB Container System and EJB Server
Url:		http://www.openejb.org/
Version:	2.1
Release:	1jpp
Epoch:		0
License:	Apache Software License 2
Group:		Internet/WWW/Servers
Vendor:		JPackage Project
Distribution:	JPackage
Source0:	openejb2-2.1.tar.gz
# svn export http://svn.apache.org/repos/asf/incubator/openejb/tags/v2_1/openejb2/

Source1:        pom-maven2jpp-depcat.xsl
Source2:        pom-maven2jpp-newdepmap.xsl
Source3:        pom-maven2jpp-mapdeps.xsl
Source4:        openejb2-2.1-jpp-depmap.xml
Source5:        openejb2.script


Patch0:		openejb2-2.1-etc-project_xml.patch
Patch1:		openejb2-2.1-project_properties.patch
Patch2:		openejb2-2.1-CMPMappingBean.patch
Patch3:		openejb2-2.1-pkgen-builder-project_xml.patch

BuildRequires:  jpackage-utils >= 0:1.6
BuildRequires:	junit
BuildRequires:	maven >= 0:1.1
BuildRequires:	saxon
BuildRequires:	saxon-scripts
#
BuildRequires:	activeio
BuildRequires:	ant
BuildRequires:	antlr
BuildRequires:	asm
BuildRequires:	axion
BuildRequires:	axis
BuildRequires:	bea-stax-api
BuildRequires:	oldcastor
BuildRequires:	cglib
BuildRequires:	concurrent
BuildRequires:	geronimo-corba-2.3-apis
BuildRequires:	geronimo-ejb-2.1-api
BuildRequires:	geronimo-j2ee-connector-1.5-api
BuildRequires:	geronimo-j2ee-deployment-1.1-api
BuildRequires:	geronimo-j2ee-management-1.0-api
BuildRequires:	geronimo-jacc-1.0-api
BuildRequires:	geronimo-jaxrpc-1.1-api
BuildRequires:	geronimo-jms-1.1-api
BuildRequires:	geronimo-jta-1.0.1B-api
BuildRequires:	geronimo-qname-1.1-api
BuildRequires:	geronimo-saaj-1.1-api
BuildRequires:	geronimo-servlet-2.4-api
BuildRequires:	geronimo11-server-j2ee-base
BuildRequires:	geronimo11-server-base
BuildRequires:	geronimo11-base
BuildRequires:	geronimo11-dependency-plugin
BuildRequires:	jakarta-commons-cli
BuildRequires:	jakarta-commons-discovery
BuildRequires:	jakarta-commons-fileupload
BuildRequires:	jakarta-commons-jelly-tags-velocity 
BuildRequires:	jakarta-commons-logging
BuildRequires:	jakarta-commons-primitives
BuildRequires:	jakarta-oro
BuildRequires:	log4j
BuildRequires:	mx4j
BuildRequires:	regexp
BuildRequires:	tranql
BuildRequires:	velocity
BuildRequires:	wsdl4j
BuildRequires:	xerces-j2
BuildRequires:	xml-commons-apis
BuildRequires:	xmlbeans
BuildRequires:	xpp3
BuildRequires:	xstream
#
# core
Requires:	activeio 
Requires:	axis
Requires:	cglib
Requires:	concurrent
Requires:	geronimo11-server-j2ee-base
Requires:	geronimo11-server-base
Requires:	geronimo11-base
Requires:	geronimo-corba-2.3-apis
Requires:	geronimo-ejb-2.1-api
Requires:	geronimo-j2ee-connector-1.5-api
Requires:	geronimo-j2ee-management-1.0-api
Requires:	geronimo-jacc-1.0-api
Requires:	geronimo-jaxrpc-1.1-api
Requires:	geronimo-jta-1.0.1B-api
Requires:	geronimo-saaj-1.1-api
Requires:	geronimo-servlet-2.4-api
Requires:	jakarta-commons-discovery
Requires:	jakarta-commons-logging
Requires:	log4j
Requires:	mx4j
Requires:	oldcastor
Requires:	tranql
Requires:	xml-commons-apis
Requires:	xerces-j2

%if %{gcj_support}
BuildRequires:          java-gcj-compat-devel
Requires(post):         java-gcj-compat
Requires(postun):       java-gcj-compat
%endif
%if ! %{gcj_support}
BuildArch:      noarch
%endif
BuildRoot:	%{_tmppath}/%{name}-%{version}-buildroot

%description
OpenEJB is an open source, modular, configurable, and 
extendable EJB Container System and EJB Server.
OpenEJB comes with fast, lightweight EJB Servers for 
both Local and Remote access. 
That's right, deploy your EJBs into the container system, 
then just start the Remote EJB Server from the command 
line! Or, put OpenEJB in your class path and use it as 
an embedded library through the Local EJB Server.
As a container system, OpenEJB works like a big plug-in for
middleware servers like Web servers, CORBA servers, and 
application servers. By plugging in OpenEJB these servers 
obtain instant EJB compliance for hosting 
Enterprise JavaBeans! 

%package builders
Summary:	Builder Modules for %{name}
Group:		Development/Libraries/Java
Requires:	%{name} = %{epoch}:%{version}-%{release}
Requires:	ant
Requires:	bea-stax-api
Requires:	geronimo-j2ee-deployment-1.1-api
Requires:	geronimo-jacc-1.0-api
Requires:	geronimo-jta-1.0.1B-api
Requires:	geronimo11-base
Requires:	geronimo11-server-base
Requires:	jakarta-commons-logging
Requires:	mx4j
Requires:	tranql
Requires:	xmlbeans

%description builders
%{summary}.

%package webadmin
Summary:	Webadmin Modules for %{name}
Group:		Development/Libraries/Java
Requires:	%{name} = %{epoch}:%{version}-%{release}
Requires:	activeio
Requires:	geronimo-ejb-2.1-api
Requires:	jakarta-commons-fileupload
Requires:	log4j
Requires:	oldcastor
Requires:	regexp

%description webadmin
%{summary}.

%package javadoc
Summary:	Javadoc for %{name}
Group:		Development/Documentation
Requires(post):   /bin/rm,/bin/ln
Requires(postun): /bin/rm

%description javadoc
%{summary}.

%prep
%setup -q -n %{name}
chmod -R go=u-w *
for j in $(find . -name "*.jar"); do
	mv $j $j.no
done

export DEPCAT=$(pwd)/openejb-2.1.1-depcat.new.xml
echo '<?xml version="1.0" standalone="yes"?>' > $DEPCAT
echo '<depset>' >> $DEPCAT
for p in $(find . -name project.xml); do
    pushd $(dirname $p)
    /usr/bin/saxon project.xml %{SOURCE1} >> $DEPCAT
    popd
done
echo >> $DEPCAT
echo '</depset>' >> $DEPCAT
/usr/bin/saxon $DEPCAT %{SOURCE2} > openejb-2.1.1-depmap.new.xml

%patch0 -b .sav
%patch1 -b .sav
%patch2 -b .sav
%patch3 -b .sav

# used org.activeio.xnet.StandardServiceStackGBean which is g1_0
rm modules/core/src/test/org/openejb/server/httpd/HttpServerTest.java

# repository for geronimo dependency plugin
mkdir -p .maven/repository/JPP/jars
ln -sf $(build-classpath xmlbeans/xbean) .maven/repository/JPP/jars/xbean-0.jar
ln -sf $(build-classpath bea-stax-api) .maven/repository/JPP/jars/stax-api-0.jar
ln -sf $(build-classpath maven) .maven/repository/JPP/jars/maven-0.jar
ln -sf $(build-classpath maven-model) .maven/repository/JPP/jars/maven-model-0.jar
ln -sf $(build-classpath geronimo11/service-builder) .maven/repository/JPP/jars/geronimo-service-builder-1.1.jar
ln -sf $(build-classpath junit) .maven/repository/JPP/jars/junit-0.jar
ln -sf $(build-classpath xerces-j2) .maven/repository/JPP/jars/xerces-0.jar
ln -sf $(build-classpath xml-commons-apis) .maven/repository/JPP/jars/xml-apis-0.jar
ln -sf $(build-classpath jline) .maven/repository/JPP/jars/jline-0.jar

%build
for p in $(find . -name project.xml); do
    pushd $(dirname $p)
    cp project.xml project.xml.orig
    /usr/bin/saxon -o project.xml project.xml.orig %{SOURCE3} map=%{SOURCE4}
    popd
done

mkdir -p .maven/repository/JPP/plugins/geronimo11/
pushd .maven/repository/JPP/plugins/geronimo11/
ln -sf $(build-classpath geronimo11/geronimo-dependency-plugin)
ln -sf $(build-classpath geronimo11/geronimo-deployment-plugin)
popd

mkdir -p .maven/repository/xmlbeans/jars
ln -sf $(build-classpath xmlbeans/xbean) .maven/repository/xmlbeans/jars/xbean-0.jar
mkdir -p .maven/repository/stax/jars
ln -sf $(build-classpath bea-stax-api) .maven/repository/stax/jars/stax-api-0.jar
mkdir -p .maven/repository/maven/jars
ln -sf $(build-classpath maven) .maven/repository/maven/jars/maven-0.jar
ln -sf $(build-classpath maven-model) .maven/repository/maven/jars/maven-model-0.jar
mkdir -p .maven/repository/geronimo/jars
ln -sf $(build-classpath geronimo11/service-builder) .maven/repository/geronimo/jars/geronimo-service-builder-1.1.jar
mkdir -p .maven/repository/junit/jars
ln -sf $(build-classpath junit) .maven/repository/junit/jars/junit-0.jar
mkdir -p .maven/repository/xerces/jars
ln -sf $(build-classpath xerces-j2) .maven/repository/xerces/jars/xerces-0.jar
mkdir -p .maven/repository/xml-apis/jars
ln -sf $(build-classpath xml-commons-apis) .maven/repository/xml-apis/jars/xml-apis-0.jar
mkdir -p .maven/repository/jline/jars
ln -sf $(build-classpath jline) .maven/repository/jline/jars/jline-0.jar

mkdir -p .maven/repository/JPP/plugins
ln -sf /usr/share/maven/repository/JPP/plugins/maven-xmlbeans-plugin.jar .maven/repository/JPP/plugins/xmlbeans-maven-plugin.jar

export MAVEN_HOME_LOCAL=$(pwd)/.maven

maven \
        -Dmaven.repo.remote=file:/usr/share/maven/repository \
        -Dmaven.home.local=$MAVEN_HOME_LOCAL \
        -Dmaven.test.failure.ignore=true \
        -Dmaven.multiproject.excludes=modules/itests/project.xml \
        -Dgoal=default,javadoc:generate \
        multiproject:goal

%install
rm -rf $RPM_BUILD_ROOT

# jars
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}/%{name}

install -m 644 \
	modules/core/target/%{bname}-core-%{version}.jar \
        $RPM_BUILD_ROOT%{_javadir}/%{name}/core-%{version}.jar
install -m 644 \
	modules/openejb-builder/target/%{bname}-builder-%{version}.jar \
        $RPM_BUILD_ROOT%{_javadir}/%{name}/builder-%{version}.jar
install -m 644 \
	modules/pkgen-builder/target/%{bname}-pkgen-builder-%{version}.jar \
        $RPM_BUILD_ROOT%{_javadir}/%{name}/pkgen-builder-%{version}.jar
install -m 644 \
	modules/webadmin/target/%{bname}-webadmin-clienttools.jar \
        $RPM_BUILD_ROOT%{_javadir}/%{name}/webadmin-clienttools-%{version}.jar
install -m 644 modules/webadmin/target/%{bname}-webadmin-ejbgen.jar \
        $RPM_BUILD_ROOT%{_javadir}/%{name}/webadmin-ejbgen-%{version}.jar
install -m 644 modules/webadmin/target/%{bname}-webadmin-main.jar \
        $RPM_BUILD_ROOT%{_javadir}/%{name}/webadmin-main-%{version}.jar
(cd $RPM_BUILD_ROOT%{_javadir}/%{name} && for jar in *-%{version}*; do ln -sf ${jar} `echo $jar| sed  "s|-%{version}||g"`; done)


# server
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/%{name}
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/%{name}/bin
install -m 755 %{SOURCE5} \
        $RPM_BUILD_ROOT%{_datadir}/%{name}/bin
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/%{name}/conf
install -m 644 modules/core/src/conf/*.xml \
        $RPM_BUILD_ROOT%{_datadir}/%{name}/conf
install -m 644 modules/core/src/conf/*.conf \
        $RPM_BUILD_ROOT%{_datadir}/%{name}/conf
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/%{name}/lib
pushd $RPM_BUILD_ROOT%{_datadir}/%{name}/lib
ln -sf %{_javadir}/%{name}/core.jar openejb-core.jar
ln -sf $(build-classpath xml-commons-apis)
ln -sf $(build-classpath log4j)
ln -sf $(build-classpath geronimo-j2ee-connector-1.5-api)
ln -sf $(build-classpath oldcastor) castor.jar
ln -sf $(build-classpath xerces-j2)
ln -sf $(build-classpath commons-logging)
ln -sf $(build-classpath oro)
popd 

install -d -m 755 $RPM_BUILD_ROOT%{_localstatedir}/log/%{name}
ln -sf %{_localstatedir}/log/%{name} \
        $RPM_BUILD_ROOT%{_datadir}/%{name}/logs

# javadoc
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
for md in core openejb-builder pkgen-builder webadmin; do
        install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/$md
        cp -pr modules/$md/target/docs/apidocs/* \
                $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/$md
done
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name} # ghost symlink

%if %{gcj_support}
%{_bindir}/aot-compile-rpm
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%post javadoc
rm -f %{_javadocdir}/%{name}
ln -s %{name}-%{version} %{_javadocdir}/%{name}

%postun javadoc
if [ "$1" = "0" ]; then
  rm -f %{_javadocdir}/%{name}
fi

%if %{gcj_support}
%postun
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%preun
(cd %{_datadir}/%{name}/lib
rm -f *.jar
)

%post
%if %{gcj_support}
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%files
%defattr(-,root,root)
%{_javadir}/%{name}/core-%{version}.jar
%{_javadir}/%{name}/core.jar
%{_datadir}/%{name}/*
%{_localstatedir}/log/%{name}
%if %{gcj_support}
%attr(-,root,root) %dir %{_libdir}/gcj/%{name}
%attr(-,root,root) %{_libdir}/gcj/%{name}/core-%{version}.jar.*
%endif

%files builders
%defattr(-,root,root)
%{_javadir}/%{name}/*builder*.jar
%if %{gcj_support}
%attr(-,root,root) %{_libdir}/gcj/%{name}/*builder-%{version}.jar.*
%endif

%files webadmin
%defattr(-,root,root)
%{_javadir}/%{name}/webadmin*.jar
%if %{gcj_support}
%attr(-,root,root) %{_libdir}/gcj/%{name}/webadmin-%{version}.jar.*
%endif

%files javadoc
%defattr(-,root,root)
%{_javadocdir}/%{name}-%{version}
%ghost %doc %{_javadocdir}/%{name}

%changelog
* Mon Nov 27 2006 Ralph Apel <r.apel at r-apel.de> 0:2.1-1jpp
- Upgrade to 2.1
- Add gcj_support option
- Add post/postun Requires for javadoc
- (B)Require oldcastor (castor = 0.9.6)
- TODO: enable starting it standalone

* Thu May 19 2005 Ralph Apel <r.apel at r-apel.de> 0:2.0-0.M2.2jpp
- Patch to castor-0.9.6

* Thu Feb 03 2005 Ralph Apel <r.apel at r-apel.de> 0:2.0-0.M2.1jpp
- Upgrade to 2.0-M2
- Process project.xml files with saxon
- Don't tamper with $HOME

* Mon Oct 04 2004 Ralph Apel <r.apel at r-apel.de> 0:2.0-0.M1.1jpp
- First release

